<?
  include "../system.inc";
  include "comlib.inc";
  include "form.inc";
  include "xml_dfile.inc";

  function tx_row_col( $tx )
  {
    $array = explode( "-", $tx );
    return( $array );
  }

  function get_same_img_recs( $rec, &$img_recs )
  {
    global $img_array;
    if ( $img_array[1] == "" ) return( 0 );
    $img_recs = "";
    $j = 0;
    for ( $i=1;$i<count($img_array);$i++ )
    {
      $array = tx_row_col( $img_array[$i] );
      if ( $rec == $array[1] )
      {
        $img_recs[$j] = $i;
        $j ++;
      }
    }
    if ( $img_recs == "" ) return( 0 );
    return( 1 );
  }

  function find_max_img_row_col( &$max_row, &$max_col )
  {
    global $img_array;
    $max_row = 0;
    $max_col = 0;
    for ( $i=1;$i<count($img_array)-1;$i++ )
    {
      $item = tx_row_col( $img_array[$i] );
      if ( $item[1] > $max_row ) $max_row = $item[1];
      if ( $item[2] > $max_col ) $max_col = $item[2];
    }
  }

  function template_is_new( $path )
  {
    global $bin_dir;
    global $tmp_dir;

    $file_id = uniqid( "AI" );
    $file_err = $tmp_dir.$file_id.".err";
    $w_run = $bin_dir."aitx -rx=new ".$path." 2> ".$file_err;
    $fp = popen( $w_run, "r" );
    $w_read = fgets( $fp, 128 );
    pclose( $fp );
    unlink( $file_err );
    if ( $w_read != "" ) return( 1 );
    else                 return( 0 );
  }

  get_service_paths( $services_file, $proc_code, $sample_path, $template_path, $library_path, $print_path );
  $apple_filename = applebasename( $apple_path_file );
  $fp = popen( $bin_dir."capencode '".$template_path.$apple_filename.".xml'", "r" );
  $w_read = fgets( $fp, 1024 );
  pclose( $fp );
  $dfile_tpl = $sys_home_dir.$w_read;
  $label_array = array();
  $value_array = array();
  $way_array = array();
  $row_array = array();
  $col_array = array();
  load_label_info( $dfile_tpl );

  $fp = popen( $bin_dir."capencode '".$template_path.$apple_filename."'", "r" );
  $w_read = fgets( $fp, 1024 );
  pclose( $fp );
  $file_tpl = $sys_home_dir.$w_read;

  $file_id = uniqid( "TX" );
  $file_tmp = $tmp_dir.$file_id.".tmp";
  $file_err = $tmp_dir.$file_id.".err";
  if ( template_is_new($file_tpl) )
    $rx_option = "-rx=new";
  else
    $rx_option = "-rx=old";
  $exec_string = $bin_dir."aitx ".$rx_option." ".$file_tpl." TX > ".$file_tmp.
                                " 2> ".$file_err;
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "aitx:¹ԥ顼(%d)<br>\n", $stat ) );
    $fp = fopen( $file_err, "r" );
    $error = fread( $fp, filesize($file_err) );
    fclose( $fp );
    mprint( sprintf( "%s<br>\n", $error ) );
//    $exec_string = "/bin/cp ".$file_tpl." ".$tmp_dir;
//    system( $exec_string, $stat );
    exit;
  }

  $fp = fopen( $file_tmp, "r" );
  $read_tx = fread( $fp, filesize($file_tmp) );
  $tx_array = explode( "\n", $read_tx );
  fclose( $fp );

  $exec_string = "/bin/rm -f ".$file_tmp;
  system( $exec_string, $stat );
  $exec_string = "/bin/rm -f ".$file_err;
  system( $exec_string, $stat );

  $file_img = $tmp_dir.$file_id.".img";
  $exec_string = $bin_dir."aitx ".$rx_option." ".$file_tpl." EPS-TX > ".$file_img. " 2> ".
                                  $file_err;
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "aitx:¹ԥ顼(%d)<br>\n", $stat ) );
    $fp = fopen( $file_err, "r" );
    $error = fread( $fp, filesize($file_err) );
    fclose( $fp );
    mprint( sprintf( "%s<br>\n", $error ) );
//    $exec_string = "/bin/cp ".$file_tpl." ".$tmp_dir;
//    system( $exec_string, $stat );
    exit;
  }

  $fp_img = fopen( $file_img, "r" );
  $read_img = fread( $fp_img, filesize($file_img) );
  $img_array = explode( "\n", $read_img );
  $img_done = "";
  for ( $i=1;$i<count($img_array)-1;$i++ )
    $img_done[$img_array[$i]] = 0;
  fclose( $fp_img );

  $exec_string = "/bin/rm -f ".$file_img;
  system( $exec_string, $stat );
  $exec_string = "/bin/rm -f ".$file_err;
  system( $exec_string, $stat );
?>
<html>
<head>
<title>untitle</title>
<? meta_language(); ?>
<script language="JavaScript"> 
<!--
var ButtonClick = 0;
function CallButtonClick1()
{
  ButtonClick = 1;
}   
function CallButtonClick2()
{   
  ButtonClick = 2;
}
function ChangeAction()
{   
  if ( ButtonClick == 1 )
  {
    document.form.target = "menuFrame";
    document.form.action = "pub_form.php4";
  }
  else
  {
    document.form.target = "menuFrame";
    document.form.action = "db_pub_form.php4";
  } 
  ButtonClick = 0;
  return true;
}
function set_current_focus( field )
{
  document.form.focus_field.value = field;
}
//-->
</script>
</head>

<body bgcolor="#FFFFFF">
<?
  tag_table_st( 0,0,0,0,0 );
  tag_tr_st();
  tag_td_st();
  mprint( sprintf("[%s]", $apple_filename) );
  tag_td_en();
  print( "<td width=\"40\">" );
  print( "</td>\n" );
  print( "<td nowrap>" );
  mprint( sprintf("<a href=\"pub_lib_ken.php4?".
                  "proc_code=%s&page_no=1\" ".
                  "target=\"mainFrame\">%s</a>",
                  urlencode($proc_code),
                  "̿") );
  print( "</td>\n" );
  print( "<td width=\"10\">" ); print( "</td>\n" );
  print( "<td nowrap>" );
  mprint( sprintf("<a href=\"pub_preview.php4?".
                  "proc_code=%s&".
                  "apple_path_file=%s\" ".
                  "target=\"mainFrame\">%s</a>",
                  urlencode($proc_code),
                  urlencode($apple_path_file),
                  "ɽ") );
  print( "</td>\n" );
  print( "<td width=\"10\">" ); print( "</td>\n" );
  print( "<td nowrap>" );
  mprint( sprintf("<a href=\"pub_ken.php4?".
                  "proc_code=%s&".
                  "page_no=1\" ".
                  ">%s</a>",
                  urlencode($proc_code),
                  "ץ") );
  print( "</td>\n" );
  tag_tr_en();
  tag_table_en();

  print( "<hr>\n" );

  print( "<form name=\"form\" method=\"post\" ".
          "action=\"pub_form_confirm.php4\">\n" );

  tag_input( "hidden","proc_code","",$proc_code );
  tag_input( "hidden","apple_path_file","",$apple_path_file );

  $max_row = 0;
  $prev_row = 0;
  $max_col = 0;
  for ( $i=1;$i<count($tx_array);$i++ )
  {
    if ( $tx_array[$i] == "" ) continue;
    $tx_item = tx_row_col( $tx_array[$i] );

    if ( $tx_item[1] != $prev_row )
    {
      if ( $prev_row > 0 )
      {
        $img_recs = "";
        $ret = get_same_img_recs( $prev_row, $img_recs );
        for ( $j=0;($j<count($img_recs) && $ret==1);$j++ )
        {
          $img_item = tx_row_col( $img_array[$img_recs[$j]] );
          tag_tr_st();
          tag_td_st();
          $tx_label = $label_array["EPS-".$img_array[$img_recs[$j]]];
          if ( $tx_label != "" )
            mprint( $tx_label."" );
          else
            mprint( "EPS-".$img_array[$img_recs[$j]]."" );
          if ( $button != "" )
          {
            $tx_default = $value_array["EPS-".$img_array[$img_recs[$j]]];
          }
          else
          {
            $line = '$EPS_'.$img_item[0]."_".$img_item[1]."_".$img_item[2];
            eval( "\$tx_default =  $line;" );
          }
          mprint( sprintf("<input type=\"text\", name=\"%s\" ".
                          "value=\"".$tx_default."\" ".
                          "onfocus=\"set_current_focus('%s')\"",
                          "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2],
                          "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2]
                         ) );
          $img_done[$img_array[$img_recs[$j]]] = 1;
          tag_td_en();
          tag_tr_en();
        }
        tag_table_en();
      }
      tag_table_st( 2,0,0,0,0 );
      $prev_row = $tx_item[1];
    }

    tag_tr_st();
    tag_tdnowrap_st();
    $tx_label = $label_array[$tx_array[$i]];
    if ( $i == 0 )
    {
      $max_row = $tx_item[1];
      $max_col = $tx_item[2];
    }
    else
    {
      if ( $max_row < $tx_item[1] ) $max_row = $tx_item[1];
      if ( $max_col < $tx_item[2] ) $max_col = $tx_item[2];
    }
    if ( $button != "" )
    {
       $tx_default = $value_array[$tx_array[$i]];
    }
    else
    {
      $line = '$'.$tx_item[0]."_".$tx_item[1]."_".$tx_item[2];
      eval( "\$tx_default =  $line;" );
    }
    $input_way = $way_array[$tx_array[$i]];
    if ( $input_way == "LINE" )
    {
      if ( $tx_label != "" ) mprint( $tx_label."" );
      else                   mprint( $tx_array[$i]."" );
      $col = $col_array[$tx_array[$i]];
      if ( $col != "" )
      {
        mprint( sprintf("<input type=\"text\" name=\"%s\" size=\"$col\" ".
                        "value=\"".$tx_default."\" ".
                        "onfocus=\"set_current_focus('%s')\"",
                        $tx_item[0]."_".$tx_item[1]."_".$tx_item[2],
                        $tx_item[0]."_".$tx_item[1]."_".$tx_item[2]
                       ) );
      }
      else
      {
        mprint( sprintf("<input type=\"text\" name=\"%s\" ".
                        "value=\"".$tx_default."\" ".
                        "onfocus=\"set_current_focus('%s')\"",
                        $tx_item[0]."_".$tx_item[1]."_".$tx_item[2],
                        $tx_item[0]."_".$tx_item[1]."_".$tx_item[2]
                       ) );
      }
    }
    else if ( $input_way == "AREA" )
    {
      if ( $tx_label != "" ) mprint( $tx_label."<br>" );
      else                   mprint( $tx_array[$i]."<br>" );
      $row = $row_array[$tx_array[$i]];
      $col = $col_array[$tx_array[$i]];
      mprint( sprintf("<textarea name=\"%s\" rows=\"$row\" cols=\"$col\">".
                      $tx_default."</textarea>",
                      $tx_item[0]."_".$tx_item[1]."_".$tx_item[2]
                     ) );
    }
    else
    {
      if ( $tx_label != "" ) mprint( $tx_label."" );
      else                   mprint( $tx_array[$i]."" );
      mprint( sprintf("<input type=\"text\" name=\"%s\" ".
                      "value=\"".$tx_default."\" ".
                      "onfocus=\"set_current_focus('%s')\"",
                      $tx_item[0]."_".$tx_item[1]."_".$tx_item[2],
                      $tx_item[0]."_".$tx_item[1]."_".$tx_item[2]
                     ) );
    }
    tag_td_en();
    tag_tr_en();
  }
  if ( $max_row > 0 )
  {
    $img_recs = "";
    $ret = get_same_img_recs( $prev_row, $img_recs );
    for ( $j=0;($j<count($img_recs) && $ret==1);$j++ )
    {
      if ( $img_done[$img_array[$img_recs[$j]]] ) continue;
      $img_item = tx_row_col( $img_array[$img_recs[$j]] );
      tag_tr_st();
      tag_td_st();
      $tx_label = $label_array["EPS-".$img_array[$img_recs[$j]]];
      if ( $tx_label != "" )
        mprint( $tx_label."" );
      else
        mprint( "EPS-".$img_array[$img_recs[$j]]."" );
      if ( $button != "" )
      {
        $tx_default = $value_array["EPS-".$img_array[$img_recs[$j]]];
      }
      else
      {
        $line = '$EPS_'.$img_item[0]."_".$img_item[1]."_".$img_item[2];
        eval( "\$tx_default =  $line;" );
      }
      mprint( sprintf("<input type=\"text\" name=\"%s\" ".
                      "value=\"".$tx_default."\" ".
                      "onfocus=\"set_current_focus('%s')\"",
                      "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2],
                      "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2]
                     ) );
      $img_done[$img_array[$img_recs[$j]]] = 1;
      tag_td_en();
      tag_tr_en();
    }
    tag_table_en();
  }

  // Ĥμ̿
  $is_left = 0;
  for ( $i=1;$i<count($img_array)-1;$i++ )
  {
    if ( !$img_done[$img_array[$i]] )
    {
      if ( !$is_left )
      {
        $is_left = 1;
        tag_table_st( 2,0,0,0,0);
      }
      $img_item = tx_row_col( $img_array[$i] );
      tag_tr_st();
      tag_td_st();
      $tx_label = $label_array["EPS-".$img_array[$i]];
      if ( $tx_label != "" )
        mprint( $tx_label."" );
      else
        mprint( "EPS-".$img_array[$i]."" );
      if ( $button != "" )
      {
        $tx_default = $value_array["EPS-".$img_array[$i]];
      }
      else
      {
        $line = '$EPS_'.$img_item[0]."_".$img_item[1]."_".$img_item[2];
        eval( "\$tx_default =  $line;" );
      }
      mprint( sprintf("<input type=\"text\" name=\"%s\" ".
                      "value=\"".$tx_default."\" ".
                      "onfocus=\"set_current_focus('%s')\"",
                      "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2],
                      "EPS_".$img_item[0]."_".$img_item[1]."_".$img_item[2]
                     ) );
      tag_td_en();
      tag_tr_en();
    }
  }
  if ( $is_left ) tag_table_en();

  tag_input("hidden","focus_field","","");
  tag_input("hidden","max_row","",$max_row);
  tag_input("hidden","max_col","",$max_col);
  tag_input("hidden","tx_prefix","","TX");
  find_max_img_row_col( $max_img_row, $max_img_col );
  tag_input("hidden","max_img_row","",$max_img_row); 
  tag_input("hidden","max_img_col","",$max_img_col); 

  print( "<p>\n" );
  mprint( "<input type=\"submit\" name=\"button\" value=\"ǧ\">" );
  mprint( "<input type=\"reset\" name=\"reset\" value=\"ꥻå\">" );
  print( "</p>\n" );
?>
</form>
</body>
</html>
