<?
  include "../system.inc";
  include "comlib.inc";
  include "form.inc";

  function template_is_new( $path )
  {
    global $bin_dir;
    global $tmp_dir;

    $file_id = uniqid( "AI" );
    $file_err = $tmp_dir.$file_id.".err";
    $w_run = $bin_dir."aitx -rx=new ".$path." 2> ".$file_err;
    $fp = popen( $w_run, "r" );
    $w_read = fgets( $fp, 128 );
    pclose( $fp );
    unlink( $file_err );
    if ( $w_read != "" ) return( 1 );
    else                 return( 0 );
  }

  get_service_paths( $services_file, $proc_code, $sample_path, $template_path, $library_path, $print_path );
  $uniq_id = uniqid( "" );
  $ai_file_id = "AI".$uniq_id;

  $apple_filename = applebasename( $apple_path_file );
  $pfp = popen( $bin_dir."capencode ".$template_path.$apple_filename, "r" );
  $ux_path = fgets( $pfp, 1024 );
  pclose( $pfp );

  $file_tpl = $sys_home_dir.$ux_path;

  $tx_file_id = uniqid( "TX" );
  $eps_file_id = uniqid( "EPS" );

  $file_tab = $tmp_dir.$tx_file_id.".tab";
  $outfile = $file_tab;
  include "./write_tabfile.inc";

  $tx_file_neat = $tmp_dir.$tx_file_id.".neat";
  $tx_file_err = $tmp_dir.$tx_file_id.".err";

  $exec_string =  $bin_dir."neat ".$file_tab." > ".$tx_file_neat.
                  " 2> ".$tx_file_err;
//print( $exec_string."<br>\n" );
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "neat:¹ԥ顼(%d)<br>\n", $stat ) );
    $fp = fopen( $tx_file_err, "r" );
    $error = fread( $fp, filesize($tx_file_err) );
    fclose( $fp );
    mprint( sprintf( "%s<br>\n", $error ) );
    $exec_string = "/bin/rm -f ".$file_tab;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$tx_file_neat;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$tx_file_err;
    system( $exec_string );
    exit;
  }
  $exec_string = "/bin/rm -f ".$file_tab;
  system( $exec_string );

  $file_tab = $tmp_dir.$eps_file_id.".tab";
  $outfile = $file_tab;
  $max_row = $max_img_row;
  $max_col = $max_img_col;
  $tx_prefix = "EPS_TX";
  include "./write_tabfile.inc";

  $eps_file_neat = $tmp_dir.$eps_file_id.".neat";
  $eps_file_err = $tmp_dir.$eps_file_id.".err";
  $stay = "";
  for ( $i=1;$i<=$max_img_col;$i++ )
  {
    if ( $stay == "" ) $stay .= $i;
    else               $stay .= " ".$i;
  }
  $exec_string =  $bin_dir."neat -stay='".$stay."' ".$file_tab." > ".
                  $eps_file_neat." 2> ".$eps_file_err;
//print( $exec_string."<br>\n" );
//exit;
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "neat:¹ԥ顼(%d)<br>\n", $stat ) );
    $fp = fopen( $eps_file_err, "r" );
    $error = fread( $fp, filesize($eps_file_err) );
    fclose( $fp );
    mprint( sprintf( "%s<br>\n", $error ) );
    $exec_string = "/bin/rm -f ".$file_tab;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$eps_file_neat;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$eps_file_err;
    system( $exec_string );
    exit;
  }
  $exec_string = "/bin/rm -f ".$file_tab;
  system( $exec_string );


  $pfp = popen( $bin_dir."capencode '".$appleshare_tmp_dir."'", "r" );
  $w_ux = fgets( $pfp, 1024 );
  pclose( $pfp );
  if ( !mkdir( $sys_home_dir.$w_ux.$uniq_id, 0777 ) )
  {
    mprint( sprintf("mkdir(%s)<br>\n", $sys_home_dir.$w_ux.$uniq_id) );
    exit;
  }
  $exec_string = $netatalk_utilities_path."apple_cp ".$file_tpl." ".
                 $sys_home_dir.$w_ux.$uniq_id;
//print( $exec_string."<br>\n" );
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "顼(%d):%s<br>\n", $stat, $exec_string ) );
    $exec_string = "/bin/rm -rf ".$sys_home_dir.$w_ux.$uniq_id;
    exit;
  }

  $file_ai = $sys_home_dir.$w_ux.$ai_file_id.".ai";
  $pfp = popen( $bin_dir."capencode ".$apple_filename, "r" );
  $ux_path = fgets( $pfp, 1024 );
  pclose( $pfp );
  $exec_string = $netatalk_utilities_path."apple_mv ".
                 $sys_home_dir.$w_ux.$uniq_id."/".$ux_path.
                 " ".$file_ai;
//print( $exec_string."<br>\n" );
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "顼(%d):%s<br>\n", $stat, $exec_string ) );
    $exec_string = "/bin/rm -rf ".$sys_home_dir.$w_ux.$uniq_id;
    exit;
  }
  $exec_string = "/bin/rm -rf ".$sys_home_dir.$w_ux.$uniq_id;
//print( $exec_string."<br>\n" );
  system( $exec_string, $stat );
  if ( $stat != 0 )
  {
    mprint( sprintf( "顼(%d):%s<br>\n", $stat, $exec_string ) );
    exit;
  }

  $file_err = $tmp_dir.$ai_file_id.".err";

  if ( template_is_new($file_tpl) )
    $rx_option = "-rx=new";
  else
    $rx_option = "-rx=old";

  $exec_string = $bin_dir."aigen -home=".$sys_home_dir." ".
                 $rx_option." -rm=y -fit=min -refpt=center ".$file_tpl.
                 " TX=".$tx_file_neat.
                 " EPS-TX=".$eps_file_neat." > ".$file_ai." 2> ".$file_err;
  system( $exec_string, $stat );
//print( $exec_string."<br>" );
//exit;
  if ( $stat != 0 )
  {
    mprint( sprintf( "aigen:¹ԥ顼(%d)<br>\n", $stat ) );
    $fp = fopen( $file_err, "r" );
    $error = fread( $fp, filesize($file_err) );
    fclose( $fp );
    mprint( sprintf( "%s<br>\n", $error ) );
    $exec_string = "/bin/rm -f ".$tx_file_neat;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$eps_file_neat;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$file_ai;
    system( $exec_string );
    $exec_string = "/bin/rm -f ".$file_err;
    system( $exec_string );
    exit;
  }

  $valid_tpl = "YES";
  $unresolved_fonts = array();
  $unresolved_fonts_type = array();
  $unresolved_fonts_tsume = array();
  $unresolved_fonts_i = 0;
  $unresolved_links = array();
  $unresolved_links_i = 0;
//  $exec_string = $bin_dir."aicheck -info=all -cap ".$file_tpl;
  $exec_string = $bin_dir."aicheck -info=all -cap ".$file_ai;
  $pfp = popen( $exec_string, "r" );
  while( 1 )
  {
    $w_read = fgets( $pfp, 1024 );
    if ( $w_read == "") break;
    $w_array = explode( "\n", $w_read );
    if ( $w_array[0] == "--INCLUDE FONT" )
    {
      $w_process = "INCLUDE_FONT";
      continue;
    }
    if ( $w_array[0] == "--LINKED FILES" )
    {
      $w_process = "LINKED_FILES";
      continue;
    }
    if ( $w_process == "INCLUDE_FONT" )
    {
      $w_line = explode( " ", $w_array[0] );
      $ret = get_font_info( $w_line[0], $font_name, $font_type, $font_tsume );
      if ( !$ret )
      {
        $unresolved_fonts[$unresolved_fonts_i] = $w_line[0];
        $unresolved_fonts_type[$unresolved_fonts_i] = $w_line[1];
        $unresolved_fonts_tsume[$unresolved_fonts_i] = $w_line[2];
        $unresolved_fonts_i ++;
      }
      else
      {
        if ( $w_line[1] != $font_type || $w_line[2] != $font_tsume )
        {
          $unresolved_fonts[$unresolved_fonts_i] = $w_line[0];
          $unresolved_fonts_type[$unresolved_fonts_i] = $w_line[1];
          $unresolved_fonts_tsume[$unresolved_fonts_i] = $w_line[2];
          $unresolved_fonts_i ++;
        }
      }
    }
    else if ( $w_process == "LINKED_FILES" )
    {
      if ( !file_exists($sys_home_dir.$w_array[0]) )
      {
        $unresolved_links[$unresolved_links_i] = $w_array[0];
        $unresolved_links_i ++;
      }
    }
  }
  pclose( $pfp );
  if ( $unresolved_fonts_i > 0 || $unresolved_links_i > 0 )
    $valid_tpl ="NO";
?>
<html>
<head>
<title>untitle</title>
<? meta_language(); ?>
<script language="JavaScript">
<!-- 
function preview( host, cgi, param )
{
  vday = new Date();
  t = vday.getTime();
  document.image1.src = "http://"+host+"/"+cgi+"?upd="+t+"&"+
                       "kick_from=JAVASCRIPT&"+param;
}
//-->
</script>
</head>

<?
  if ( $valid_tpl == "YES" )
  {
    print( "<body bgcolor=\"#FFFFFF\" onload=\"preview('$mac_server_host',".
           "'$mac_server_ai2jpeg_cgi','file=".encode_hex_string($appleshare_tmp_dir.
           $ai_file_id.".ai")."&act=delete')\">\n" );
  }
  else
  {
    print( "<body bgcolor=\"#FFFFFF\">\n" );
  }

  print( "<center>\n" );
  tag_table_st( 0,0,0,0,0 );
  tag_tr_st();
  tag_tdnowrap_st();
  mprint( "ʲΥץӥ塼򻲹ͤ˸Ƥγǧ򤷤Ƥ\n" );
  tag_td_en();
  tag_tr_en();
  tag_tr_st();
  print( "<td nowrap height=\"50\">\n" );
  tag_td_en();
  tag_tr_en();
  tag_tr_st();
  if ( $valid_tpl == "YES" )
  {
    print( "<td nowrap align=\"center\">\n" );
    printf( "<img name=\"image1\" src=\"gifs/%s\">\n", "now_processing.gif" );
  }
  else
  {
    print( "<td nowrap>\n" );
    if ( $unresolved_fonts_i > 0 )
      mprint( "ʲΥեȤСϿƤޤ<br>\n" );
    for ( $i=0;$i<$unresolved_fonts_i;$i++ )
    {
      print( $unresolved_fonts[$i].":".
             $unresolved_fonts_type[$i].":".
             $unresolved_fonts_tsume[$i]."<br>\n" );
    }
    if ( $unresolved_links_i > 0 )
      mprint( "<br>ʲΥ󥯥ե뤬СϿƤޤ<br>\n" );
    for ( $i=0;$i<$unresolved_links_i;$i++ )
    {
      $pfp = popen( $bin_dir."capdecode '".$unresolved_links[$i]."'", "r" );
      $euc = fgets( $pfp, 1024 );
      pclose( $pfp );
      mprint( $euc."<br>\n" );
    }
  }
  tag_td_en();
  tag_tr_en();
  tag_tr_st();
  print( "<td nowrap height=\"50\">\n" );
  tag_td_en();
  tag_tr_en();
  tag_tr_st();
  tag_tdnowrap_st();
  mprint( "Сκˤäƥץӥ塼ɽʤ<br>\n" );
  mprint( "礬ޤ<br>\n" );
  mprint( "ץӥ塼ɽǤʤƤ[ư]ܥˤ<br>\n" );
  mprint( "ưϲǽǤ\n" );
  tag_td_en();
  tag_tr_en();
  tag_table_en();
  print( "</center>\n" );


  $exec_string = "/bin/rm -f ".$tx_file_neat;
//print( $exec_string."<br>" );
  system( $exec_string );
  $exec_string = "/bin/rm -f ".$eps_file_neat;
//print( $exec_string."<br>" );
  system( $exec_string );
  $exec_string = "/bin/rm -f ".$tx_file_err;
//print( $exec_string."<br>" );
  system( $exec_string );
  $exec_string = "/bin/rm -f ".$eps_file_err;
//print( $exec_string."<br>" );
  system( $exec_string );
//***** this file is deleted in ai2jpeg.acgi for synchronization
//    $exec_string = "/bin/rm -f ".$file_ai;
//    system( $exec_string );
  $exec_string = "/bin/rm -f ".$file_err;
//print( $exec_string."<br>" );
  system( $exec_string );
?>
</body>
</html>
